import pandas
import sys
import math
import i2c
import time
def turnComponent(valves):
    i2c.setValves( valves )		 
    print(valves)
    time.sleep( 4.0 )

def turnValvesBJT(valves):
    i2c.setValves(valves)
    time.sleep(3)
    sensors = [255,255,255,255,255,255,255,255,255,255,255,255]
    go = True
    while go == True:
        sensors = i2c.getSensors()
        go = False;
        for x in range(0,len(sensors)):
            go = False
            if sensors[x] > 50:
                go = True
        time.sleep(0.1)
    print(sensors)
    return sensors
def turnValvesMosfet(valves):
    i2c.setValves(valves)
    time.sleep(5)
    sensors = [255,255,255,255,255,255,255,255,255,255,255,255]
    go = True
    while go == True:
        sensors = i2c.getSensors()
        print(sensors)
        go = False;
        for x in range(0,len(sensors)):
            go = False
            print(sensors[x])
            if sensors[x] > 50:
                go = True
        time.sleep(0.1)
    return sensors
def turnValvesDiode(valves):
    i2c.setValves(valves)
    time.sleep(3)
    sensors = [255,255,255,255,255,255,255,255,255,255,255,255]
    go = True
    while go == True:
        sensors = i2c.getSensors()
        print(sensors)
        go = False;
        for x in range(0,len(sensors)):
            go = False
            if sensors[x] > 50:
                go = True
        time.sleep(0.1)
    print(sensors)
    return sensors
def diode_match(vd, vrd, LED):
    global dataset
    score = sys.float_info.max
    prefer = False
    for x in range(0,len(dataset.v00)):
        if (dataset.s01[x]-dataset.s00[x]) > 0 and (dataset.s02[x]-dataset.s01[x]) > 0 and dataset.v00[x] != 80:
            if prefer == False:
                if abs(vd - (dataset.s01[x]-dataset.s00[x]))<0.02 and abs(vrd - (dataset.s02[x]-dataset.s01[x]))<0.02:
                    position = x
                    score = abs(vd - (dataset.s01[x]-dataset.s00[x]))/2 + abs(vrd - (dataset.s02[x]-dataset.s01[x]))/2
                    prefer = True 
                elif score > abs(vd - (dataset.s01[x]-dataset.s00[x]))/2 + abs(vrd - (dataset.s02[x]-dataset.s01[x]))/2:
                    position = x
                    score = abs(vd - (dataset.s01[x]-dataset.s00[x]))/2 + abs(vrd - (dataset.s02[x]-dataset.s01[x]))/2
        else:
            if abs(vd - (dataset.s01[x]-dataset.s00[x]))<0.02 and abs(vrd - (dataset.s02[x]-dataset.s01[x]))<0.02:
                if score > abs(vd - (dataset.s01[x]-dataset.s00[x]))/2 + abs(vrd - (dataset.s02[x]-dataset.s01[x]))/2:
                    position = x
                    score = abs(vd - (dataset.s01[x]-dataset.s00[x]))/2 + abs(vrd - (dataset.s02[x]-dataset.s01[x]))/2		
    valves = [dataset.v00[position],dataset.v01[position],dataset.v02[position],dataset.v03[position],dataset.v04[position],dataset.v05[position],dataset.v06[position],dataset.v07[position],dataset.v08[position],dataset.v09[position],dataset.v10[position]]

    # ZF: Saving current rotation
    rotation = valves

		#print(prefer)		
		#print("Position : %f" %position)
		#print("Score : %f" %score)
		#measured_sensors = [dataset.s00[position],dataset.s01[position],dataset.s02[position],dataset.s03[position],dataset.s04[position],dataset.s05[position],dataset.s06[position],dataset.s07[position],dataset.s08[position],dataset.s09[position],dataset.s10[position],dataset.s11[position]]
                #for x in range(0,len(measured_sensors)):
                 #   measured_sensors[x] = invDiode(measured_sensors[x])
                  #  print(measured_sensors[x])
	#print("")
		#print("Actual analog voltages")
		#print("vd desired: %f vd picked: %f diff: %f" %(vd,(dataset.s01[position]-dataset.s00[position]),abs(vd-(dataset.s01[position]-dataset.s00[position]))))
		#print("vrd desired: %f vrd picked: %f diff: %f" %(vrd,(dataset.s02[position]-dataset.s01[position]),abs(vrd-(dataset.s02[position]-dataset.s01[position]))))
		#print("")
		#print("Converted voltages for UI")
		#print("vd desired: %f vd picked: %f diff: %f" %(invconvert(vd),invconvert(dataset.s01[position]-dataset.s00[position]),invconvert(abs(vd-(dataset.s01[position]-dataset.s00[position])))))
		#print("vrd desired: %f vrd picked: %f diff: %f" %(invconvert(vrd),invconvert(dataset.s02[position]-dataset.s01[position]),invconvert(abs(vrd-(dataset.s02[position]-dataset.s01[position])))))
    temp = [score,position,(dataset.s01[position]-dataset.s00[position]),(dataset.s02[position]-dataset.s01[position])]
    tempSensor = valves[0]
    valves[0] = 0
    tempSensor1 = valves[1]
    valves[1] = LED
    print(valves);
    turnComponent(valves)
    valves[0] = tempSensor
    valves[1] = tempSensor1
    print(valves)
    sensors = turnValvesDiode(valves)
    return sensors

def mosfet_match(vds,vgs,LED): 
    global dataset
    score = sys.float_info.max
    for x in range(0,len(dataset.v00)):
        if((dataset.s06[x] - dataset.s03[x]) <=0 or (dataset.s04[x] - dataset.s03[x]) <= 0):
            score = score
        elif(score > math.sqrt(((dataset.s06[x] - dataset.s03[x])-vgs)**2+((dataset.s04[x] - dataset.s03[x])-vds)**2)):
            position = x
            score = math.sqrt(((dataset.s06[x] - dataset.s03[x])-vgs)**2+((dataset.s04[x] - dataset.s03[x])-vds)**2)
    #print("score: %f position: %f" %(score,position))
    #print("vgs: %f vds: %f" %((dataset.s06[position] - dataset.s03[position]),(dataset.s04[position] - dataset.s03[position])))
    #print("Data : v00: %f v01: %f v02: %f v03: %f v04: %f v05: %f v06: %f v07: %f v08: %f v09: %f v10: %f s00: %f s01: %f s02: %f s03: %f s04: %f s05: %f s06: %f s07: %f s08: %f s09: %f s10: %f s11: %f" %(dataset.v00[position],dataset.v01[position],dataset.v02[position],dataset.v03[position],dataset.v04[position],dataset.v05[position],dataset.v06[position],dataset.v07[position],dataset.v08[position],dataset.v09[position],dataset.v10[position],dataset.s00[position],dataset.s01[position],dataset.s02[position],dataset.s03[position],dataset.s04[position],dataset.s05[position],dataset.s06[position],dataset.s07[position],dataset.s08[position],dataset.s09[position],dataset.s10[position],dataset.s11[position]))
    valves = [dataset.v00[position],dataset.v01[position],dataset.v02[position],dataset.v03[position],dataset.v04[position],dataset.v05[position],dataset.v06[position],dataset.v07[position],dataset.v08[position],dataset.v09[position],dataset.v10[position]]
    # ZF: Saving current rotation
    rotation = valves
    tempSensor = valves[0]
    valves[0] = 1
    tempSensor1 = valves[1]
    valves[1] = LED
    print(valves)
    turnComponent(valves)
    valves[0] = tempSensor
    valves[1] = tempSensor1

    sensors = turnValvesMosfet(valves)
    #print(sensors)
    #print("Desired vgs: %f Data Point vgs: %f Measured vgs: %f" %(invconvert(vgs),invconvert((dataset.s06[position] - dataset.s03[position])),(sensors[6] - sensors[3])))
    #print("Desired vds: %f Data Point vds: %f Measured vds: %f" %(invconvert(vds),invconvert((dataset.s04[position] - dataset.s03[position])),(sensors[4] - sensors[3])))
    return sensors

# 180417 zf: send ratio instead of LEDb
# def bjt_match(Vbe,Vce,Vrb,Vrc,LEDb,LEDc):
def bjt_match( Vbe, Vce, Vrb, Vrc, LEDc, ratio ):
    global dataset
    score = sys.float_info.max
    if(Vrc == 0 and Vrb == 0):
        return [0,0,0,0,0,0,0,0,0,0,0,0]
    else:
        for x in range(0,len(dataset.v00)):
            if((dataset.s10[x] - dataset.s09[x]) <=0 or (dataset.s08[x] - dataset.s09[x]) <= 0 or (dataset.s11[x] - dataset.s10[x]) <= 0 or (dataset.s07[x] - dataset.s08[x]) <= 0):
                score = score
            elif(score > math.sqrt((dataset.s10[x] - dataset.s09[x]-Vbe)**2 + (dataset.s08[x] - dataset.s09[x]-Vce)**2 + (dataset.s11[x] - dataset.s10[x]-Vrb)**2 + (dataset.s07[x] - dataset.s08[x]-Vrc)**2)):
                position = x
                score = math.sqrt((dataset.s10[x] - dataset.s09[x]-Vbe)**2 + (dataset.s08[x] - dataset.s09[x]-Vce)**2 + (dataset.s11[x] - dataset.s10[x]-Vrb)**2 + (dataset.s07[x] - dataset.s08[x]-Vrc)**2)
    valves = [dataset.v00[position],dataset.v01[position],dataset.v02[position],dataset.v03[position],dataset.v04[position],dataset.v05[position],dataset.v06[position],dataset.v07[position],dataset.v08[position],dataset.v09[position],dataset.v10[position]] 
    tempSensor = valves[0]
    valves[0] = 2
    tempSensor1 = valves[1]

    # 180417 zf: send LEDc in index 1 instead of LEDb
    #valves[1] = LEDb
    valves[1] = LEDc
    tempSensor2 = valves[2]

    # 180417 zf: send ratio in index 2 instead of LEDc
    #valves[2] = LEDc
    valves[2] = ratio
    print(valves)
    turnComponent(valves)
    valves[0] = tempSensor
    valves[1] = tempSensor1
    valves[2] = tempSensor2
    print(valves)
    sensors = turnValvesBJT(valves)
    return sensors

def convert(v):
		return abs(0.02)/0.7*v

def invconvert(v):
		return 0.7/abs(0.02)*v

def diodeInv(sensors,Vd,Vrd):
    ratioVd = abs(sensors[1]-sensors[0])/Vd + 0.000000000001
    ratioVrd = abs(sensors[2]-sensors[1])/Vrd + 0.00000000000001
    
    sensorsVd = [0,0,0,0,0,0,0,0,0,0,0,0]
    sensorsVrd = [0,0,0,0,0,0,0,0,0,0,0,0]

    for i in range(0,12):
        sensorsVd[i] = sensors[i]/ratioVd
        sensorsVrd[i] = sensors[i]/ratioVrd

    score1 = abs(Vd - (sensorsVd[1] - sensorsVd[0])) + abs(Vrd-(sensorsVd[2]-sensorsVd[1]))
    score2 = abs(Vd - (sensorsVrd[1] - sensorsVrd[0])) + abs(Vrd-(sensorsVrd[2]-sensorsVrd[1]))
    if(score1 < score2):
        sensors = sensorsVd
    else:
        sensors = sensorsVrd
    print("Vd")
    print(sensors[1]- sensors[0])
    print("Vrd")
    print(sensors[2]-sensors[1])
    return sensors;


def mosfetInv(sensors,Vds,Vgs,Vrd):
    print("Finding Ratio")
    #print(Vds)
    #print(Vgs)
    #print(Vgs)
    ratioVds = abs(sensors[4]-sensors[3])/Vds + 0.000000000001
    ratioVgs = abs(sensors[6]-sensors[3])/Vgs + 0.00000000000001
    ratioVrd = abs(sensors[5]-sensors[4])/(Vrd + 0.0000000000001) + 0.0000000000001

    sensorsVds = [0,0,0,0,0,0,0,0,0,0,0,0]
    sensorsVgs = [0,0,0,0,0,0,0,0,0,0,0,0]
    sensorsVrd = [0,0,0,0,0,0,0,0,0,0,0,0]

    for i in range(0,12):
        sensorsVds[i] = sensors[i]/ratioVds
        sensorsVgs[i] = sensors[i]/ratioVgs
        sensorsVrd[i] = sensors[i]/ratioVrd

    score1 = abs(Vds - (sensorsVds[4] - sensorsVds[3])) + abs(Vgs-(sensorsVds[6]-sensorsVds[3])) + abs(Vrd - (sensorsVds[5] - sensorsVds[4]))
    score2 = abs(Vds - (sensorsVgs[4] - sensorsVgs[3])) + abs(Vgs-(sensorsVgs[6]-sensorsVgs[3])) + abs(Vrd - (sensorsVgs[5] - sensorsVgs[4]))
    score3 = abs(Vds - (sensorsVrd[4] - sensorsVrd[3])) + abs(Vgs-(sensorsVrd[6]-sensorsVrd[3])) + abs(Vrd - (sensorsVrd[5] - sensorsVrd[4]))
    if(score1 < score2 and score1 < score3):
        print("Vds")
        score2 = 0
    if(score2 < score1 and score2 < score3):
        print("vgs")
        sensorsVgs[5] = sensorsVrd[5]
        sensorsVgs[4] = sensorsVrd[4]
        sensors = sensorsVgs
    if(score3 < score1 and score3 < score2):
        print("vrd")
        sensorsVrd[6] = sensorsVgs[6]
        sensorsVrd[3] = sensorsVgs[3]
        sensors = sensorsVrd

    print(Vgs)
    print(sensors[6]-sensors[3])
    print(Vrd)
    print(sensors[5]-sensors[4])
    return sensors

def bjtInv(sensors,Vbe,Vce,Vrb,Vrc):
    print("Finding Ratio")
    ratioVbe = abs(sensors[10]-sensors[9])/Vbe + 0.000000000001
    ratioVce = abs(sensors[8]-sensors[9])/Vce + 0.00000000000001
    ratioVrb = abs(sensors[11]-sensors[10])/Vrb + 0.0000000000001
    ratioVrc = abs(sensors[7]-sensors[8])/Vrc + 0.0000000000001

    sensorsVbe = [0,0,0,0,0,0,0,0,0,0,0,0]
    sensorsVce = [0,0,0,0,0,0,0,0,0,0,0,0]
    sensorsVrb = [0,0,0,0,0,0,0,0,0,0,0,0]
    sensorsVrc = [0,0,0,0,0,0,0,0,0,0,0,0]

    for i in range(0,12):
        sensorsVbe[i] = sensors[i]/ratioVbe
        sensorsVce[i] = sensors[i]/ratioVce
        sensorsVrb[i] = sensors[i]/ratioVrb
        sensorsVrc[i] = sensors[i]/ratioVrc

    score1 = abs(Vbe - (sensorsVbe[10]-sensorsVbe[9]))
    score1 = score1 + abs(Vce - (sensorsVbe[8]-sensorsVbe[9]))
    score1 = score1 + abs(Vrb - (sensorsVbe[11]-sensorsVbe[10]))
    score1 = score1 + abs(Vrc - (sensorsVbe[7]-sensorsVbe[8]))
    score2 = abs(Vbe - (sensorsVce[10]-sensorsVce[9]))
    score2 = score2 + abs(Vce - (sensorsVce[8]-sensorsVce[9]))
    score2 = score2 + abs(Vrb - (sensorsVce[11]-sensorsVce[10]))
    score2 = score2 + abs(Vrc - (sensorsVce[7]-sensorsVce[8]))
    score3 = abs(Vbe - (sensorsVrb[10]-sensorsVrb[9]))
    score3 = score3 + abs(Vce - (sensorsVrb[8]-sensorsVrb[9]))
    score3 = score3 + abs(Vrb - (sensorsVrb[11]-sensorsVrb[10]))
    score3 = score3 + abs(Vrc - (sensorsVrb[7]-sensorsVrb[8])) 
    score4 = abs(Vbe - (sensorsVrc[10]-sensorsVrc[9]))
    score4 = score4 + abs(Vce - (sensorsVrc[8]-sensorsVrc[9]))
    score4 = score4 + abs(Vrb - (sensorsVrc[11]-sensorsVrc[10]))
    score4 = score4 + abs(Vrc - (sensorsVrc[7]-sensorsVrc[8]))

    if(score1 < score2 and score1 < score3 and score1 < score4):
        print("Vbe")
        sensorsVbe[7] = sensorsVrc[7]
        sensorsVbe[8] = sensorsVrc[8]
        sensorsVbe[11] = abs(sensorsVrb[11]-sensorsVrb[10])+sensorsVbe[10]
        sensors = sensorsVbe
    if(score2 < score1 and score2 < score3 and score2 < score4):
        print("Vce")
        sensorsVce[10] = sensorsVrb[10]
        sensorsVce[11] = sensorsVrb[11]
        sensorsVce[7] = abs(sensorsVrc[7]-sensorsVrc[8])+sensorsVce[8]
        sensors = sensorsVce
    if(score3 < score1 and score3 < score2 and score3 < score4):
        print("Vrb")
        sensorsVrb[8] = sensorsVce[8]
        sensorsVrb[9] = sensorsVce[9]
        sensorsVrb[7] = abs(sensorsVrc[7]-sensorsVrc[8])+sensorsVrb[8]
        sensors = sensorsVrb
    if(score4 < score1 and score4 < score2 and score4 < score3):
        print("Vrc")
        sensorsVrc[10] = sensorsVbe[10]
        sensorsVrc[9] = sensorsVbe[9]
        sensorsVrc[11] = abs(sensorsVrb[11]-sensorsVrb[10])+sensorsVrc[10]
        sensors =  sensorsVrc
    print(abs(sensors[10]-sensors[9]))
    print(abs(sensors[8]-sensors[9]))
    print(abs(sensors[11]-sensors[10]))
    print(abs(sensors[7]-sensors[8]))
    return sensors
def bjt_cutoff(Vbb,Vcc,LEDb,LEDc):
    sensors = [0]*12
    valves = [0]*11
    valves[4] = 90
    valves[2] = 90
    tempSensor = valves[0]
    valves[0] = 2
    tempSensor1 = valves[1]
    valves[1] = LEDb
    tempSensor2 = valves[2]
    valves[2] = LEDc
    turnComponent(valves)
    valves[0] = tempSensor
    valves[1] = tempSensor1
    valves[2] = tempSensor2
    print(valves)
    sensors = turnValvesBJT(valves)
    sensors[7] = Vcc
    sensors[8] = Vcc
    sensors[9] = 0
    sensors[10] = Vbb
    sensors[11] = Vbb
    return sensors

def bjt(Vbb,Vcc,Rb,Rc):
    global dataset
    names = ["v00","v01","v02","v03","v04","v05","v06","v07","v08","v09","v10","s00","s01","s02","s03","s04","s05","s06","s07","s08","s09","s10","s11"]
    data = "bjt.csv"
    dataset = pandas.read_csv(data, names=names)
    Vbe = 0.7;
    
    # 180417 zf: Ic/Ib ratio for led b speed
    ratio = 100

    B = 100;
    Ib = (Vbb-Vbe)/Rb
    Ic = B*Ib
    Ie = Ib+Ic
    Vrb = Ib*Rb
    Vrc = Ic*Rc
    Vce = Vcc - Vrc
    LEDb = 0
    LEDc = 0
    if(Ib < 0 and Vce > 0):
        # 180417 zf: Ic/Ib ratio for led b speed
        ratio = 0

        Ib = 0
        Ic = 0
        Ie = 0
        Vrb = 0
        Vrc = 0
        Vce = Vcc
        return bjt_cutoff(Vbb,Vcc,LEDb,LEDc)
    elif(Vce >= 0.5):
        LEDc = int(math.ceil(Ic/0.00375*100))
        if(LEDc > 100):
            LEDc = 100
        LEDb = int(math.ceil(LEDc/10))        
    elif(Vce < 0.5 and Vce > 0):
        # 180417 zf: Ic/Ib ratio for led b speed
        ratio = 10  

        Ic = 10*Ib
        Ie = Ib + Ic
        Vrb = Ib*Rb
        Vrc = Ic*Rc
        Vce = Vcc - Vrc
        LEDc = int(math.ceil(Ic/0.00375*100))
        if(LEDc > 100):
            LEDc = 100
        LEDb = int(math.ceil(LEDc/10))
    else:
        print("Broken");
        return [-1]*12
    print("Vbe")
    print(Vbe)
    print("Vce")
    print(Vce)
    print("Vrb")
    print(Vrb)
    print("Vrc")
    print(Vrc)
    print("Ib")
    print(Ib)
    print("Ic")
    print(Ic)
    Vbe = convert(Vbe)
    Vce = convert(Vce)
    Vrb = convert(Vrb)
    Vrc = convert(Vrc)
    
    # 180417 zf: send ratio instead of ledb
    # sensors = bjt_match(Vbe,Vce,Vrb,Vrc,LEDb,LEDc)
    sensors = bjt_match( Vbe, Vce, Vrb, Vrc, LEDc, ratio )

    Vbe = invconvert(Vbe)
    Vce = invconvert(Vce)
    Vrb = invconvert(Vrb)
    Vrc = invconvert(Vrc)
    sensors = bjtInv(sensors,Vbe,Vce,Vrb,Vrc)
    return sensors

def mosfet1(vdd,vgg,rd):
    global dataset
    names = ["v00","v01","v02","v03","v04","v05","v06","v07","v08","v09","v10","s00","s01","s02","s03","s04","s05","s06","s07","s08","s09","s10","s11"]
    data = "mosfet.csv"
    dataset = pandas.read_csv(data, names=names)
    cox = 200*(10**(-9))
    mu = 200
    w = 25*(10**(-6))
    l = 1*(10**(-6))
    vt = 0.7
    vgs = vgg
    Id = mu*cox*(w/l)*((vgs-vt)**2)/2
    vrd = Id*rd
    vds = vdd - vrd
    Is = Id
    if(vgg <= 0.7):
        return mosfet_cutoff(vdd,vgg,0)
    if(vds <0):
        print("Broken")
        return 1
    elif(vgs < vt):
        Id = 0
        vrd = Id*rd
        vds = vdd - vrd
        Is = Id
    elif(vds < vgs - vt):
        Id = mu*cox*(w/l)*(((vgs-vt)*vds)-((vds**2)/2))
        vrd = Id*rd
        vds = vdd - vrd
        Is = Id
    else:
        Id = mu*cox*(w/l)*((vgs-vt)**2)/2
        vrd = Id*rd
        vds = vdd - vrd
        Is = Id

    LED = int(math.ceil(Is/0.000245*100))
    vds = convert(vds)
    vgs = convert(vgs)

    sensors = mosfet_match(vds,vgs,LED)
    vds = invconvert(vds)
    vgs = invconvert(vgs)
    print(vds)
    print(vgs)
    print(Id)
    sensors = mosfetInv(sensors,vds,vgs,vrd)
    return sensors

def mosfet_cutoff(Vdd,Vgg,LED):
    sensors = [0]*12
    valves = [0]*11
    valves[8] = 90
    tempSensor = valves[0]
    valves[0] = 1
    tempSensor1 = valves[1]
    valves[1] = LED
    print(valves)
    turnComponent(valves)
    valves[0] = tempSensor
    valves[1] = tempSensor1
    sensors = turnValvesMosfet(valves)
    sensors[5] = Vdd
    sensors[4] = Vdd
    sensors[3] = 0
    sensors[6] = Vgg
    return sensors

def diode(vin,rd):
    global dataset
    names = ["v00","v01","v02","v03","v04","v05","v06","v07","v08","v09","v10","s00","s01","s02","s03","s04","s05","s06","s07","s08","s09","s10","s11"]
    data = "diode.csv"
    dataset = pandas.read_csv(data, names=names)
    vd = 0.7;
    if(vin <= vd):
        return diode_cutoff(vin)
    vrd = vin - vd;
    i = vrd/rd
    print("id")
    print(id)
    LED = int(math.ceil(i/.0093*100))
    print("LED")
    print(LED)
    vin = convert(vin)
    vd = convert(vd)
    vrd = convert(vrd)
    sensors = diode_match(vd,vrd,LED)
    vd = invconvert(vd)
    vrd = invconvert(vrd)
    sensors = diodeInv(sensors,vd,vrd)
    return sensors

def diode_cutoff(Vin):
    sensors = [0]*12
    sensors[1] = Vin
    sensors[2] = Vin
    valves = [0]*11
    valves[10] = 90
    tempSensor = valves[0]
    valves[0] = 0
    tempSensor1 = valves[1]
    valves[1] = 0
    print(valves)
    turnComponent(valves)
    valves[0] = tempSensor
    valves[1] = tempSensor1
    sensors = turnValvesDiode(valves)
    sensors[0] = 0
    sensors[1] = Vin
    sensors[2] = Vin
    return sensors

def ask():						 
    global dataset
    names = ["v00","v01","v02","v03","v04","v05","v06","v07","v08","v09","v10","s00","s01","s02","s03","s04","s05","s06","s07","s08","s09","s10","s11"]
    component = int(input("Chose: 1 Diode. 2 Mosfet. 3 BJT. : "))
    if component == 1:
        data = "diode.csv"
        dataset = pandas.read_csv(data, names=names)
        vin = float(input("Vin: "))
        rd = float(input("Rd: "))
        diode(vin,rd)
    if component == 2:
        data = "mosfet.csv"
        dataset = pandas.read_csv(data, names=names)
        vdd = float( input( "Vdd: " ) )
        vgg = float( input( "Vgg: " ) )
        rd = float( input( "Rd: "))
        mosfet(vdd,vgg,rd)
    if component == 3:
        data = "bjt.csv"
        dataset = pandas.read_csv(data, names=names)
        Vbb = float( input( "Vbb: " ) )
        Vcc = float( input( "Vcc: " ) )
        Rb = float( input( "Rb: "))
        Rc = float( input( "Rc: "))
        bjt(Vbb,Vcc,Rb,Rc)

def SendCurrents( current1, current2=98 ):
    ret = [98] * 11
    ret[1] = int( current1 * 1000 )
    ret[2] = int( current2 * 1000 )
    print( ret )
    i2c.setValves( ret )

def chooseComponent():						 
		global dataset
		names = ["v00","v01","v02","v03","v04","v05","v06","v07","v08","v09","v10","s00","s01","s02","s03","s04","s05","s06","s07","s08","s09","s10","s11"]
		component = int(input("Chose: 1 Diode. 2 Mosfet. 3 BJT. : "))
		if component == 1:
				askDiode( names )

		if component == 2:
				askBJT( names )

		if component == 3:
				askMOSFET( names )

		return names 

def askDiode( names ):
		data = "diode.csv"
		dataset = pandas.read_csv( data, names=names )
		vin = float( input( "Vin: " ) )
		rd = float( input( "Rd: " ) )
		diode( vin, rd ) 

def askBJT( names ):
		data = "bjt.csv"
		dataset = pandas.read_csv( data, names=names )

def askMOSFET( names ):
		data = "mosfet.csv"
		dataset = pandas.read_csv( data, names=names )
		vdd = float( input( "Vdd: " ) )
		vgg = float( input( "Vgg: " ) )
		rd = float( input( "Rd: "))
		mosfet(vdd,vgg,rd)


def DiodeReturnToZero():
		# ZF: Richard said to pass vin and rd, however, I don't think we need it
		# because of the previous rotation saved
		i2c.setValves( [99,99,99,99,99,99,99,99,99,99,99] )

def main():
		global rotation
		names = ask()
		while( True ):
				print ("Type: 1:change values, 2:start over, or 3:quit")
				x = input()
				if int(x) == 1:
						DiodeReturnToZero()
						askDiode( names )
				elif int(x) == 2:
						DiodeReturnToZero()
						chooseComponent()
				elif int(x) == 3:				 
						DiodeReturnToZero()		 
						break
if __name__ == "__main__":
		main()
